# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use Config;
use Test;
my $iswin32;
BEGIN {
    $| = 1;
    if ($] <  5.003) {
	eval("require Win32");
	$iswin32 = ! $@;
    } else {
	$iswin32 = $^O eq "MSWin32";
    }
    plan tests => 13
}
END {print "not ok 1\n" unless $loaded;}
use Test::Cmd;
$loaded = 1;
ok(1);

######################### End of black magic.

$My_Config{_pl} = $iswin32 ? '.pl' : '';

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my($run_env, $ret, $testx, $test);

$run_env = Test::Cmd->new(workdir => '');
ok($run_env);

$ret = $run_env->write('run', <<EOF);
print STDOUT "run:  STDOUT\\n";
print STDERR "run:  STDERR\\n";
exit 0;
EOF
ok($ret);

my $runx = "runx$My_Config{_pl}";

$ret = $run_env->write($runx, <<EOF);
$Config{startperl}
print STDOUT "runx:  STDOUT\\n";
print STDERR "runx:  STDERR\\n";
exit 0;
EOF
ok($ret);

$wdir = $run_env->workdir;
ok($wdir);
$ret = chdir($wdir);
ok($ret);
$ret = chmod(0755, $runx);
ok($ret == 1);

if ($iswin32) {
    ok(-f 'run');
    ok(-f $runx);
} else {
    ok(! -x 'run');
    ok(-x $runx);
}

# Everything before this was merely preparation of our "source
# directory."  Now we do some real tests.
$testx = Test::Cmd->new(prog => 'runx', workdir => '');
ok($testx);

$testx->run('.', '');
ok($? == 0);

$test = Test::Cmd->new(prog => 'run', interpreter => "$^X", workdir => '');
ok($test);

$test->run('.', '');
ok($? == 0);
