# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use Test;
my $iswin32;
BEGIN {
    $| = 1;
    if ($] <  5.003) {
	eval("require Win32");
	$iswin32 = ! $@;
    } else {
	$iswin32 = $^O eq "MSWin32";
    }
    plan tests => $iswin32 ? 15 : 18
}
END {print "not ok 1\n" unless $loaded;}
use Test::Cmd;
$loaded = 1;
ok(1);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my($test, $ret, $wdir);

$test = Test::Cmd->new(workdir => '', subdir => 'foo');
ok($test);
$ret = $test->subdir('bar');
ok($ret == 1);
$wdir = $test->workdir;
ok($wdir);
$ret = chdir($wdir);
ok($ret);

my $foo_succeed = Test::Cmd->catfile('foo', 'succeed');
my $foo_fail = Test::Cmd->catfile('foo', 'fail');

$ret = $test->subdir($foo_succeed);
ok($ret == 1);
if (! $iswin32) {
    # I don't understand why, but setting read-only on a directory
    # on Windows NT still allows you to create a file.
    # Let's still test this under UNIX.
    $ret = chmod(0500, 'foo');
    ok($ret == 1);
    $ret = $test->subdir($foo_fail);
    ok(! $ret);
}

my $sub_dir = Test::Cmd->catfile('sub', 'dir');
my $sub_dir_ectory = Test::Cmd->catfile('sub', 'dir', 'ectory');

$ret = $test->subdir($sub_dir_ectory, 'sub');
ok($ret == 1);

my $one = Test::Cmd->catfile('one');
my $one_two = Test::Cmd->catfile('one', 'two');
my $one_two_three = Test::Cmd->catfile('one', 'two', 'three');

$ret = $test->subdir($one, $one_two, $one_two_three);
ok($ret == 3);

ok(-d 'foo');
ok(-d 'bar');
ok(-d $foo_succeed);
if (! $iswin32) {
    ok(! -d $foo_fail);
}
ok( -d 'sub');
ok(! -d $sub_dir);
ok(! -d $sub_dir_ectory);
ok(-d $one_two_three);
