# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use Test;
my $iswin32;
BEGIN {
    $| = 1;
    if ($] <  5.003) {
	eval("require Win32");
	$iswin32 = ! $@;
    } else {
	$iswin32 = $^O eq "MSWin32";
    }
    plan tests => $iswin32 ? 12 : 15
}
END {print "not ok 1\n" unless $loaded;}
use Test::Cmd;
$loaded = 1;
ok(1);

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my($test, $ret, $wdir);

my $foo_file2 = Test::Cmd->catfile('foo', 'file2');
my $bar_file3 = Test::Cmd->catfile('bar', 'file3');

$test = Test::Cmd->new(workdir => '', subdir => 'foo');
ok($test);
$ret = $test->write('file1', <<EOF);
Test file #1.
EOF
ok($ret);
$ret = $test->write($foo_file2, <<EOF);
Test file #2.
EOF
ok($ret);
$ret = $test->write($bar_file3, <<EOF);
Test file #3 (should not get created).
EOF
ok(! $ret);
$wdir = $test->workdir;
ok($wdir);
if (! $iswin32) {
    # I don't understand why, but setting read-only on a directory
    # on Windows NT still allows you to create a file.
    # Let's still test this under UNIX.
    $ret = chmod(0500, $wdir);
    ok($ret == 1);
    $ret = $test->write('file4', <<EOF);
Test file #4 (should not get created).
EOF
    ok(! $ret);
}

$ret = chdir($wdir);
ok($ret);
ok(-f 'file1');
ok(-d 'foo');
ok(-f $foo_file2);
ok(! -f $bar_file3);
ok(! -d 'bar');
if (! $iswin32) {
    ok(! -f 'file4');
}
